Imports MySql.Data
Imports MySql.Data.MySqlClient
Imports System.Net.Mail

Partial Class My_account
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Page.IsPostBack = False Then
            Try
                ' Check if the user have the authority to see this page, he have to be logged in
                Dim user As String = Page.User.Identity.Name

                ' Select the account information for the authorized user from the users table
                Try
                    Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                    Dim sql As String = "SELECT * FROM Users WHERE Username = @Username"

                    ' The Using block is used to call dispose (close) automatically even if there are an exception.
                    Using cn As New MySqlConnection(ConnString), _
                          cmd As New MySqlCommand(sql, cn)
                        cmd.Parameters.Add("@Username", MySqlDbType.VarChar, 80).Value = user

                        cn.Open()
                        ' We use MySqlDataReader and just want to select one single row, the Using block
                        ' is used to call dispose (close) automatically even if there are an exception.
                        Using reader As MySqlDataReader = cmd.ExecuteReader(System.Data.CommandBehavior.SingleRow)
                            While reader.Read()
                                txtUserID.Text = reader("UserID").ToString()
                                txtUserName.Text = reader("Username").ToString()
                                txtCompanyName.Text = reader("Company").ToString()
                                txtOrganisationNumber.Text = reader("OrgNumber").ToString()
                                txtContact.Text = reader("Contact").ToString()
                                txtAttention.Text = reader("Attention").ToString()
                                txtAdress.Text = reader("Adress").ToString()
                                txtPostalCode.Text = reader("PostalCode").ToString()
                                txtCity.Text = reader("City").ToString()
                                txtCountry.Text = reader("Country").ToString()
                            End While
                        End Using

                    End Using
                Catch ex As Exception
                    Response.Write(ex.Message)
                End Try
            Catch ex As Exception
                Response.Write(ex.Message)
            End Try
        End If
    End Sub
    Protected Sub btnUppdatera_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUppdatera.Click
        SqlEx.Text = ""
        Try
            ' Update user information according to the users changes for the specific UserID in the Users table
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "UPDATE Users SET Username=@Username, Company=@Company, OrgNumber=@OrgNumber, Contact=@Contact, Attention=@Attention, Adress=@Adress, PostalCode=@PostalCode, City=@City, Country=@Country WHERE UserID=@UserID"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New MySqlConnection(ConnString), _
                  cmd As New MySqlCommand(sql, cn)
                cmd.Parameters.Add("@UserID", MySqlDbType.Int32).Value = txtUserID.Text
                cmd.Parameters.Add("@Username", MySqlDbType.VarChar, 80).Value = txtUserName.Text
                cmd.Parameters.Add("@Company", MySqlDbType.VarChar, 50).Value = txtCompanyName.Text
                cmd.Parameters.Add("@OrgNumber", MySqlDbType.VarChar, 15).Value = txtOrganisationNumber.Text
                cmd.Parameters.Add("@Contact", MySqlDbType.VarChar, 50).Value = txtContact.Text
                cmd.Parameters.Add("@Attention", MySqlDbType.VarChar, 50).Value = txtAttention.Text
                cmd.Parameters.Add("@Adress", MySqlDbType.VarChar, 50).Value = txtAdress.Text
                cmd.Parameters.Add("@PostalCode", MySqlDbType.VarChar, 10).Value = txtPostalCode.Text
                cmd.Parameters.Add("@City", MySqlDbType.VarChar, 50).Value = txtCity.Text
                cmd.Parameters.Add("@Country", MySqlDbType.VarChar, 50).Value = txtCountry.Text

                cn.Open()
                ' Execute the UPDATE statement.
                cmd.ExecuteNonQuery()
                ' Send mail to the user
                CustomerMailChangeUserInfo()
                ' Logout the user because the Username could have been changed
                LogoutUser()

            End Using
        Catch ex As MySqlException
            Select Case ex.Number
                Case 2601
                    SqlEx.Text = "* Given E-mail already exists"
                Case Else
                    Response.Write(ex.Message)
            End Select
        End Try
    End Sub
    Protected Sub btnChangePassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnChangePassword.Click
       
        Try
            ' Update the password field in the Users table for the specific UserID according to what the user has entered
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "UPDATE Users SET Password=@Password WHERE UserID=@UserID"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New MySqlConnection(ConnString), _
                  cmd As New MySqlCommand(sql, cn)
                cmd.Parameters.Add("@UserID", MySqlDbType.Int32).Value = txtUserID.Text
                cmd.Parameters.Add("@Password", MySqlDbType.VarChar, 80).Value = txtPassword.Text

                cn.Open()
                cmd.ExecuteNonQuery()
                ' Send mail to the user
                CustomerMailChangePassword()
                ' Logout the user because the password have been changed
                LogoutUser()

            End Using
        Catch ex As MySqlException
            Response.Write(ex.Message)
        End Try
    End Sub
    Private Sub CustomerMailChangeUserInfo()
        Dim ToAddress As String = txtUserName.Text

        ' Create the mail message
        Dim SendEmail As New MailMessage("info@mycompany.com", ToAddress)

        ' Properties for the mail message
        SendEmail.Subject = "Updated data!"
        SendEmail.Body = "<html><body><b>Updated data!!</b><br />You receive this email because of updated user information. Your E-mail is now as follows:<br /><br />E-mail:" & " " & txtUserName.Text & "</body></html>"
        SendEmail.IsBodyHtml = True

        ' Send the MailMessage (will use the Web.config settings)
        Dim smtp As New SmtpClient
        smtp.Send(SendEmail)
    End Sub
    Private Sub CustomerMailChangePassword()
        Dim ToAddress As String = txtUserName.Text

        ' Create the mail message
        Dim SendEmail As New MailMessage("info@mycompany.com", ToAddress)

        'Properties for the mail message
        SendEmail.Subject = "Changed password!"
        SendEmail.Body = "<html><body><b>Changed password!</b><br />You are receiving this email because you have changed your password. Your new password is now as follows:<br /><br />Password:" & " " & txtPassword.Text & "</body></html>"
        SendEmail.IsBodyHtml = True

        ' Send the MailMessage (will use the Web.config settings)
        Dim smtp As New SmtpClient
        smtp.Send(SendEmail)
    End Sub
    Private Sub LogoutUser()
        FormsAuthentication.SignOut()
        FormsAuthentication.RedirectToLoginPage()
    End Sub
End Class

